//=============================================================================
// RPG Maker MZ - Liora
// ----------------------------------------------------------------------------
// (C)2025 aura-dev
// This software is released under the MIT License.
// http://opensource.org/licenses/mit-license.php
// ----------------------------------------------------------------------------
// Version
// 1.0.0 02/04/2025
//=============================================================================

/*:
 * @target MZ
 * @plugindesc Liora
 * @author aura-dev
 * @url https://gitgud.io/auragamedev/auramz
 *
 * @help liora.js
 *
 * Base Liora plugin for adding extra functionality like accessing extra stats.
 * 
 * @param arousalLabel_cte
 * @text Arousal Label
 * @desc Text displayed in the Status Menu for the Arousal stat
 * @default Arousal
 * 
 * @param decayLabel_cte
 * @text Decay Label
 * @desc Text displayed in the Status Menu for the Decay stat
 * @default Decay
 * 
 */

window.Liora = window.Liora || {};

(($) => {
	const PLUGIN_ID = "liora";
	$.Params = PluginManager.parameters(PLUGIN_ID);

	$.actorId = 1;
	$.arousal = function() {
		return $gameVariables.value(6);
	}
	$.maxArousal = function() {
		return $gameVariables.value(362);
	}

	$.Rean = {};
	$.Rean.decay = function() {
		return $gameVariables.value(212);
	}
	$.Rean.actorId = 2;

	Object.defineProperties($, {
		"arousalLabel": { get: () => TextManager.message(`${PLUGIN_ID}-arousalLabel_cte`) || $.Params.arousalLabel_cte }
	});

	Object.defineProperties($.Rean, {
		"decayLabel": { get: () => TextManager.message(`${PLUGIN_ID}-decayLabel_cte`) || $.Params.decayLabel_cte }
	});

	$.sumMeta = function(battler, property) {
		const metaObjects = battler.traitObjects().filter(traitObject => traitObject.meta[property]);
		return metaObjects.reduce((r, traitObject) => r + eval(traitObject.meta[property]), 0);
	};

	$.groupBy = function(list, grouping) {
		return list.reduce((res, item) => {
			const group = grouping(item);
			if (res[group]) res[group].push(item); else res[group] = [item];
			return res;
		}, {});
	}

	Game_Actor.prototype.sexSkill = function() {
		return $.sumMeta(this, "sex_skill");
	};

	Game_Actor.prototype.penisSize = function() {
		return $.sumMeta(this, "penis_size");
	};

	$.statusGauges = {
		arousal: { currentValue: () => $.arousal(), maxValue: () => $.maxArousal(), label: () => $.arousalLabel, gaugeColor1: TLB.Param.SKAUIB.corruptiongauge_color1, gaugeColor2: TLB.Param.SKAUIB.corruptiongauge_color2 },
		decay: { currentValue: () => $.Rean.decay(), maxValue: () => 50, label: () => $.Rean.decayLabel, gaugeColor1: TLB.Param.SKAUIB.vicecolor1, gaugeColor2: TLB.Param.SKAUIB.vicecolor2 },
		prestige: { currentValue: () => $.Edgar.prestige(), maxValue: () => 200, label: () => $.Edgar.prestigeLabel }
	};

	$._Window_Status_refresh = Window_Status.prototype.refresh
	Window_Status.prototype.refresh = function() {
		$._Window_Status_refresh.call(this);
		if (this._actor) {
			const stat = Object.keys($.statusGauges)[this._actor.actorId() - 1];
			if (stat) {
				this.placeSKALargeGauge(this._actor, stat, 277, 29);
			}
		}
	};

	$._Sprite_SKAGauge_currentValue = Sprite_SKAGauge.prototype.currentValue;
	Sprite_SKAGauge.prototype.currentValue = function() {
		if ($.statusGauges[this._statusType]) return $.statusGauges[this._statusType].currentValue();
		return $._Sprite_SKAGauge_currentValue.call(this);
	};

	$._Sprite_SKAGauge_currentMaxValue = Sprite_SKAGauge.prototype.currentMaxValue;
	Sprite_SKAGauge.prototype.currentMaxValue = function() {
		return $.statusGauges[this._statusType]?.maxValue() || $._Sprite_SKAGauge_currentMaxValue.call(this);
	};

	$._Sprite_SKAGauge_label = Sprite_SKAGauge.prototype.label;
	Sprite_SKAGauge.prototype.label = function() {
		return $.statusGauges[this._statusType]?.label() || $._Sprite_SKAGauge_label.call(this);
	};

	$._Sprite_SKAGauge_labelX = Sprite_SKAGauge.prototype.labelX;
	Sprite_SKAGauge.prototype.labelX = function() {
		return $.statusGauges[this._statusType] ? 2 : $._Sprite_SKAGauge_labelX.call(this);
	};

	$._Sprite_SKAGauge_bitmapWidth = Sprite_SKAGauge.prototype.bitmapWidth;
	Sprite_SKAGauge.prototype.bitmapWidth = function() {
		return $.statusGauges[this._statusType] ? TLB.Param.SKAUIB.corruptiongauge_width : $._Sprite_SKAGauge_bitmapWidth.call(this);
	};

	$._Sprite_SKAGauge_bitmapHeight = Sprite_SKAGauge.prototype.bitmapHeight;
	Sprite_SKAGauge.prototype.bitmapHeight = function() {
		return $.statusGauges[this._statusType] ? TLB.Param.SKAUIB.corruptiongauge_height : $._Sprite_SKAGauge_bitmapHeight.call(this);
	};

	$._Sprite_SKAGauge_isValid = Sprite_SKAGauge.prototype.isValid;
	Sprite_SKAGauge.prototype.isValid = function() {
		return $.statusGauges[this._statusType] ? true : $._Sprite_SKAGauge_isValid.call(this);
	};

	$._Sprite_SKAGauge_drawGaugeRect = Sprite_SKAGauge.prototype.drawGaugeRect;
	Sprite_SKAGauge.prototype.drawGaugeRect = function(x, y, width, height) {
		if ($.statusGauges[this._statusType]) {
			const params = TLB.Param.SKAUIB;
			image = params.corruptiongauge_barborder;
			x += 1;
			y -= 4;
			width = params.corruptiongauge_width - 2;
			height = params.corruptiongauge_height - 2;
			const source = ImageManager.loadMenu(image);
			this.bitmap.blt(source, 0, 0, source.width, source.height, 0, 0, width, height);
			Sprite_Gauge.prototype.drawGaugeRect.call(this, x, y, width, height);
		} else {
			$._Sprite_SKAGauge_drawGaugeRect.call(this, x, y, width, height);
		}
	};

	$._Sprite_SKAGauge_gaugeColor1 = Sprite_SKAGauge.prototype.gaugeColor1;
	Sprite_SKAGauge.prototype.gaugeColor1 = function() {
		return $.statusGauges[this._statusType]?.gaugeColor1 || $._Sprite_SKAGauge_gaugeColor1.call(this);
	};

	$._Sprite_SKAGauge_gaugeColor2 = Sprite_SKAGauge.prototype.gaugeColor2;
	Sprite_SKAGauge.prototype.gaugeColor2 = function() {
		return $.statusGauges[this._statusType]?.gaugeColor2 || $._Sprite_SKAGauge_gaugeColor2.call(this);
	};
})(Liora);

