# Translation

## Tools

* [POEdit](https://poedit.net/): Free translation tool for editing JSON language files.

## How to Add a New Language

1. Install [python](https://www.python.org/downloads/).
>>> [!important] :loud_sound: Important 
Make sure Python is added to your system's **PATH** during installation. 
>>>
2. Open a terminal in the repo and execute

	```bash
    python scripts/creat_empty_translation.py INSERT_LANGUAGE_CODE_HERE
    ```
3. Add the language code into the `Languages.json`.
4. Translate the individual `.json` files.
>>> [!tip] :bulb: Tip 
Instead of manually editing the raw files, it's recommended to use a translation tool (such as POEdit) for assistance.
>>>

## How to Create a Progress Dashboard

Install python as above and open a terminal in the repo and execute

```bash
python scripts/creat_dashboard.py
```

Open the newly created public/index.html in a browser to see an overview over the game's translation progress.

## Context-Dependent Translations

In case your translation is dependent on context (for example you are translating into a language where the plural depends on the number of items),
then you can employ `@if` and `@else` checks in the translation text to provide different translations based on the condition.

Be aware that the FIRST satisfied condition in the list will be used, meaning higher-priority conditions should be given first.
If no conditions at all are met, Base Language text will be used, so you should generally always define an `@else` case.

````
＠if V[1] = 1
There is \V[1] item.
＠if V[1] >= 100
There are a lot of items.
＠if V[1] >= 200
There are too many items.
＠else
There are \V[1] items.
````

## Tips & Tricks

* While the main game only makes use to 2 lines for items and skills, we have extended the engine to use 3
to allow for translations needing extra space to have an extra line.
* The `"DefaultFont"` key in the `Extras.json` doesn't have to be translated. 
It contains the name of the font that should be used for the current language.
If the default font works with your language, you can simply remove this entry.